﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.5
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore

	Private Button1 As B4XView
	Private Button2 As B4XView
	Private Button3 As B4XView
	Private Button4 As B4XView
	Private Button5 As B4XView

	Private ImageView1 As B4XView

	Public commonLabel As B4XView
	Private scienceLabel As B4XView
	Private wiringLabel As B4XView
	Private canopyLabel As B4XView
	Private fertLabel As B4XView
	Private repottingLabel As B4XView
	Private rootLabel As B4XView
	Private sprayLabel As B4XView

	Private operation As Int
	Private datewiredButton As B4XView
	Private datepotButton As B4XView
	Private datefertButton As B4XView
	Private datesprayButton As B4XView
	Private datecanopyButton As B4XView
	Private daterootButton As B4XView
	
	Private stylesCustomListView1 As CustomListView
	Private lstData As List
	
''''	Dim nowYear, nowMonth, nowDay As Int
	Private style1, style2, style3 As String
	Private save As Button
		
	Private Label8 As Label
	Private acceptDate As B4XView
	
	Private Panel2 As B4XView
	Private daySpinner As Spinner
	Private monthSpinner As Spinner
	Private yearSpinner As Spinner
	Private soilB4XRadioButton1 As B4XRadioButton
	Private soilB4XRadioButton2 As B4XRadioButton
	Private soilB4XRadioButton3 As B4XRadioButton
	Private soilB4XRadioButton4 As B4XRadioButton
	Private soilB4XRadioButton5 As B4XRadioButton
	Private soilB4XRadioButton6 As B4XRadioButton
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	lstData = File.ReadList(File.DirAssets, "styles.csv")
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	
	B4XPages.SetTitle (Me, "MANAGE tree record")
	
	Root.LoadLayout("manage")
	
	For Each Text As String In lstData
		Text = Text.Replace(",", "-")
		stylesCustomListView1.AddTextItem(Text, Text)
	Next

'	nowYear  = DateTime.GetYear(DateTime.Now)
'	nowMonth = DateTime.GetMonth(DateTime.Now)
'	nowDay   = DateTime.GetDayOfMonth(DateTime.Now)

	Panel2.Visible = False
	Dim MinYear As Int
	Dim MaxYear As Int
	Dim i As Int
	Dim d As Long

	' Initialize Year spinner
	MinYear = 2000
	MaxYear = 2040
	For i = MinYear To MaxYear
		yearSpinner.Add(i)
	Next
	' Initialize Month spinner
	For i = 1 To 12
		DateTime.DateFormat = "d/M/yyyy"
		d = DateTime.DateParse("1/" & i & "/2016")
		DateTime.DateFormat = "MMM"
		monthSpinner.Add(DateTime.Date(d))
	Next
	' Initialize Day spinner
	For i = 1 To 31
		If i < 10 Then
			daySpinner.Add("0" & i)
		Else
			daySpinner.Add(i)
		End If
	Next
	
	SetCurrentDate
	acceptDate.Text =  daySpinner.SelectedItem & "-" & monthSpinner.SelectedItem & "-" & yearSpinner.SelectedItem

    commonLabel.Text = "XXX"
End Sub

Sub B4xPage_Appear
	' when the page appears get the tree for which the index or name was sent
	' from the VIEW page.  There probably shouldn't be a menu option for MANAGE
	' on the landing page
	
	''	 	commonLabel.Text = "XXX"
End Sub

Private Sub Button1_Click
	xui.MsgboxAsync(" SAVE this tree Record", "Manage the work record for your trees")
End Sub

Private Sub Button2_Click
	B4XPages.ShowPage("MainPage")
End Sub

Private Sub Button3_Click
	xui.MsgboxAsync(" DELETE : Deleting a record is permanent", "Manage the work record for your trees")
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

'Private Sub wiringLabel_Click
'	
'End Sub
'
'Private Sub canopyB4XRadioButton_Checked
'	
'End Sub
'
'Private Sub rootB4XRadioButton_Checked
'	
'End Sub

' *****  WIRED
Private Sub datewiredButton_Click
	operation = 0
	datewiredButton.Visible = False
	Panel2.Visible = True
End Sub

' ***** RE-POTTED
Private Sub datepotButton_Click
	operation = 1
	datepotButton.Visible = False
	Panel2.Visible = True
End Sub

' ***** FERTILISED
Private Sub datefertButton_Click
	operation = 2
	datefertButton.Visible = False
	Panel2.Visible = True
End Sub

' ***** SPRAYED
Private Sub datesprayButton_Click
	operation = 3
	datesprayButton.Visible = False
	Panel2.Visible = True
End Sub

' ***** CANOPY PRUNE
Private Sub datecanopyButton_Click
	operation = 4
	datecanopyButton.Visible = False
	Panel2.Visible = True
End Sub

' ***** ROOT PRUNE
Private Sub daterootButton_Click
	operation = 5
	daterootButton.Visible = False
	Panel2.Visible = True
End Sub

Private Sub stylesCustomListView1_ItemClick (Index As Int, Value As Object)
	Dim components() As String
	
	components = Regex.Split("-", Value) 'the pipe needs to be escaped as it has special meaning in Regex.
	style1 = components(0)
	style2 = components(1)
	style3 = components(2)
	
	xui.MsgboxAsync(style1 & " " & style2 & " " & style3, "Chosen Style components")
End Sub

Private Sub stylesCustomListView1_ReachEnd
	stylesCustomListView1.JumpToItem (0)
End Sub


'Private Sub Button4_Click
'	
'End Sub
'
'Private Sub Button5_Click
'	
'End Sub

Private Sub daySpinner_ItemClick (Position As Int, Value As Object)
	acceptDate.Text =  daySpinner.SelectedItem & "-" & monthSpinner.SelectedItem & "-" & yearSpinner.SelectedItem
End Sub

Private Sub monthSpinner_ItemClick (Position As Int, Value As Object)
	PopulateDD
	acceptDate.Text =  daySpinner.SelectedItem & "-" & monthSpinner.SelectedItem & "-" & yearSpinner.SelectedItem
End Sub

Private Sub yearSpinner_ItemClick (Position As Int, Value As Object)
	PopulateDD
	acceptDate.Text =  daySpinner.SelectedItem & "-" & monthSpinner.SelectedItem & "-" & yearSpinner.SelectedItem
End Sub

Sub SetCurrentDate()
	yearSpinner.SelectedIndex = yearSpinner.IndexOf(DateTime.GetYear(DateTime.Now))
	monthSpinner.SelectedIndex = DateTime.GetMonth(DateTime.Now) - 1
	daySpinner.SelectedIndex = DateTime.GetDayOfMonth(DateTime.Now) - 1
End Sub

Sub PopulateDD
	Select (monthSpinner.SelectedIndex + 1)
		Case 1, 3, 5, 7, 8, 10, 12
			If daySpinner.Size = 28 Then
				daySpinner.Add("29")
			End If
			If daySpinner.Size = 29 Then
				daySpinner.Add("30")
			End If
			If daySpinner.Size = 30 Then
				daySpinner.Add("31")
			End If
		Case 4, 6, 9, 11
			If daySpinner.Size = 28 Then
				daySpinner.Add("29")
			End If
			If daySpinner.Size = 29 Then
				daySpinner.Add("30")
			End If
			If daySpinner.Size = 31 Then
				daySpinner.RemoveAt(30)
			End If
		Case Else ' 2
			If LeapYear(yearSpinner.SelectedItem) Then ' Leap Year
				If daySpinner.Size = 31 Then
					daySpinner.RemoveAt(30)
				End If
				If daySpinner.Size = 30 Then
					daySpinner.RemoveAt(29)
				End If
				If daySpinner.Size = 28 Then
					daySpinner.Add("29")
				End If
			Else
				If daySpinner.Size = 31 Then
					daySpinner.RemoveAt(30)
				End If
				If daySpinner.Size = 30 Then
					daySpinner.RemoveAt(29)
				End If
				If daySpinner.Size = 29 Then
					daySpinner.RemoveAt(28)
				End If
			End If
	End Select
End Sub

Sub LeapYear(Year As Int) As Boolean
	If Year Mod 400 = 0 Then Return True
	If Year Mod 100 = 0 Then Return False
	If Year Mod 4 = 0 Then Return True
	Return False
End Sub

Private Sub acceptDate_Click
	Select operation
		Case  0
			datewiredButton.Text = acceptDate.text
			datewiredButton.Visible = True
		Case  1
			datepotButton.Text = acceptDate.text
			datepotButton.Visible = True
		Case  2
			datefertButton.Text = acceptDate.text
			datefertButton.Visible = True
		Case  3
			datesprayButton.Text = acceptDate.text
			datesprayButton.Visible = True
		Case  4
			datecanopyButton.Text = acceptDate.text
			datecanopyButton.Visible = True
		Case  5
			daterootButton.Text = acceptDate.text
			daterootButton.Visible = True
		Case Else
	
	End Select
	
	Panel2.Visible = False
End Sub

' Method
Public Sub NewValue(Value As String)
Log (Value)
	commonLabel.Text = Value
End Sub