﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.5
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	
	Private SQL2 As SQL
	Private Cursor1 As Cursor
	
	Private xui As XUI 'ignore
	
	Private treeAS_CardSlider1 As AS_CardSlider

	Private Button2 As B4XView

	Private nexttreeLabel As B4XView
	Private previoustreeLabel As B4XView
	Private Label1 As B4XView
	Private common As B4XView  ' this is hidden but has to set to send it to manage

	Private Label3 As B4XView
	Private Label4 As B4XView
	Private Label5 As B4XView
	Private Label5a As B4XView
	Private Label5b As B4XView
	Private Label7 As B4XView
	Private Label7a As B4XView
	Private Label8 As B4XView
	Private Label8a As B4XView
	Private Label9 As B4XView
	Private Label9a As B4XView
	Private Label10 As B4XView
	Private Label10a As B4XView
	Private Label11 As B4XView
	Private Label11a As B4XView
	Private Label12 As B4XView
	Private Label12a As B4XView
	Private Label13 As B4XView
	
	Private acquired As B4XView
	Private colltype As B4XView
	Private indig As B4XView
	Private decidu As B4XView
	Private conifer As B4XView
	Private price As B4XView
	Private location As B4XView
	Private age As B4XView
	Private style As B4XView
	
	Private lstData As List
	Private lstStyles As List
	Private lstDetail As String 'List
	'Private lstLEN As Int

	Private managetree As Button
	
	Public Value As String
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	' change the styles.csv to read the list of trees which is what the layout will expect
	' read tree list from database
	
	lstStyles = File.ReadList(File.DirAssets, "styles.csv")
	lstData.Initialize
	LoadTrees
'	lstDetail.Initialize
	
'	lstLEN = lstData.Size
	
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root

	Root.LoadLayout("view")
	B4XPages.SetTitle (Me, "VIEW tree records")
	
	treeAS_CardSlider1.LazyLoading = False

	Dim i = 0 As Int

	For Each Text As String In lstData
		Dim xpnl As B4XView = xui.CreatePanel("")
		xpnl.SetLayoutAnimated(0,0,0,treeAS_CardSlider1.ItemWidth,treeAS_CardSlider1.mBase.Height)
		'xpnl.Color = xui.Color_ARGB(255,Rnd(0,256),Rnd(0,256),Rnd(0,256))
		xpnl.LoadLayout("detailLabel")
		
		If (i == 0) Then
			Label13.Text = treeAS_CardSlider1.Index + 1

	' AT THIS POINT USE THE TREE COMMON NAME TO READ THE DETAIL FROM db
		    readDetail (lstData.Get(treeAS_CardSlider1.Index))

			Dim components1() As String
			components1 = Regex.Split(",", lstData.Get(treeAS_CardSlider1.Index))

			Dim components2() As String
			components2 = Regex.Split(",", lstDetail) 

			common.Text = components2(1)  ' used to send value to manage
'			B4XPages.MainPage.newa.NewValue(common.Text)
			Label3.Text = components2(2)

			Dim parseStyle As String
			parseStyle = lstStyles.Get(components2(11))

			Dim components3() As String
			components3 = Regex.Split(",", parseStyle)
				
			Label5.Text = components3(0)	' style First
			Label5a.Text = components3(1)	' style Japanese
			Label5b.Text = components3(2)	' style basic / Modified
			acquired.Text = components2(3)	' date acquired
			colltype.Text = components2(4)	' source of the tree
			indig.Text = components2(5)		' indiginous/exotic
			decidu.Text = components2(6)	' deciduous/evergreen
			conifer.Text = components2(7)	' broadleaf/conifer
			price.Text = components2(8)		' purchase price
			location.Text = components2(9)	' location at which collected
			age.Text = components2(10)		' approx/actual age
			style.Text = components2(11)	'  style in use
			Label7a.Text = components2(12)	' wiring
			Label8a.Text = components2(13)	' repot
			Label9a.Text = components2(14)	' fert
			Label10a.Text = components2(15)	' spray
			Label12a.Text = components2(16)	' root
			Label11a.Text = components2(17)	' canopy
		End If
		
		Dim xlbl_Text As B4XView = xpnl.GetView(0)
		xlbl_Text.Text = Text
		
		treeAS_CardSlider1.AddPage(xpnl,i)
		
		i = i + 1
	Next
End Sub

Private Sub Button1_Click
	xui.MsgboxAsync("VIEW Tree Records", "VIEW all tree records")
End Sub

Private Sub Button2_Click
	B4XPages.ShowPage("MainPage")
End Sub

Private Sub treeAS_CardSlider1_PageChanged(OldIndex As Int, NewIndex As Int)
	Label13.Text = NewIndex + 1

	readDetail (lstData.Get(treeAS_CardSlider1.Index))
	
'	Dim components1() As String
'	components1 = Regex.Split(",", lstData.Get(treeAS_CardSlider1.Index)) 'the pipe needs to be escaped as it has special meaning in Regex.

	Dim components2() As String
	components2 = Regex.Split(",", lstDetail) 'the pipe needs to be escaped as it has special meaning in Regex.

	common.Text = components2(1)
	Label3.Text = components2(2)

	Dim parseStyle As String
	parseStyle = lstStyles.Get(components2(11))

	Dim components3() As String
	components3 = Regex.Split(",", parseStyle)
				
	Label5.Text = components3(0) ' style first
	Label5a.Text = components3(1)  ' style Japanese
	Label5b.Text = components3(2)  ' style Basic / modified
	acquired.Text = components2(3)
	colltype.Text = components2(4)
	indig.Text = components2(5)
	decidu.Text = components2(6)
	conifer.Text = components2(7)
	price.Text = components2(8)
	location.Text = components2(9)
	age.Text = components2(10)
	style.Text = components2(11)
	Label7a.Text = components2(12) ' wiring
	Label8a.Text = components2(13) ' repot
	Label9a.Text = components2(14) ' fert
	Label10a.Text = components2(15) ' spray
	Label12a.Text = components2(16) ' root
	Label11a.Text = components2(17) ' canopy

End Sub

'Private Sub treeAS_CardSlider1_LazyLoadingAddContent(Parent As B4XView, Value As Object)
'	Parent.LoadLayout("detailLabel")
'		
'	Dim xlbl_Text As B4XView = Parent.GetView(0)
'	xlbl_Text.Text = "Item #" & (Value+1)
'End Sub

Private Sub previoustreeLabel_Click
	treeAS_CardSlider1.PreviousPage
End Sub

Private Sub nexttreeLabel_Click
	treeAS_CardSlider1.NextPage
End Sub

Private Sub detailLabel_Click

End Sub

Sub LoadTrees
	SQL2.Initialize(File.DirDefaultExternal, "bonsai.db", False)    'DirRootExternal
	Dim rs As ResultSet = SQL2.ExecQuery("SELECT CommName FROM Trees ")

	Do While rs.NextRow
		Dim element As String
		element = rs.GetString("Trees.CommName")
		
	' 		Log (row(0) & " -> " & row(1) & " -> " & row(2) & " -> " & row(3) & " -> " & row(4))

		lstData.Add(element)

	Loop
	rs.Close
End Sub

Sub readDetail (treekey As String)
	Dim Query = "SELECT * FROM Trees WHERE CommName = '" & treekey &"'" As String
	
	SQL2.Initialize(File.DirDefaultExternal, "bonsai.db", False)    'DirRootExternal

	Cursor1 = Starter.SQL1.ExecQuery(Query)
	Cursor1.Position = 0
	
	lstDetail = Cursor1.GetString2(0) & "," & Cursor1.GetString2(1) & "," & Cursor1.GetString2(2) & "," & Cursor1.GetString2(3)	 & "," & Cursor1.GetString2(4) & "," & Cursor1.GetString2(5) & "," & Cursor1.GetString2(6)	& "," & Cursor1.GetString2(7)	& "," & Cursor1.GetString2(8)	& "," & Cursor1.GetString2(9)	& "," & Cursor1.GetString2(10)	& "," & Cursor1.GetString2(11)	& "," & Cursor1.GetString2(12)	& "," & Cursor1.GetString2(13)	& "," & Cursor1.GetString2(14)	& "," & Cursor1.GetString2(15)	& "," & Cursor1.GetString2(16)	& "," & Cursor1.GetString2(17)	& "," & Cursor1.GetString2(18)

' Log (lstDetail)

End Sub

'Reads the database IDs in IDList
'Sub ReadDataBaseIDs
'	Private Row As Int
'	Private Cursor1 As Cursor
'	
'	''	Starter.ProductIDList.Initialize		'initialize the ID list
'
'	'We read only the ID column and put them in a List
'	Cursor1 = Starter.SQL1.ExecQuery("SELECT rowID FROM Products")
'	Log (Cursor1.RowCount)
'	If Cursor1.RowCount > 0 Then						'check if entries exist
'		Starter.ProductIDList.Initialize						'initialize the ID list
'		For Row = 0 To Cursor1.RowCount - 1
'			Cursor1.Position = Row								'set the Cursor to each row
'			Starter.ProductIDList.Add(Cursor1.GetInt2(0))		'add the ID's to the ID list
'		Next
'	Else
'		ToastMessageShow("No items found", False)
'	End If
'	Cursor1.Close								'close the cursor, we don't need it anymore
'End Sub

Private Sub managetree_Click
	' 3 - Calls B4XMainPage's method

'	 Log (common.Text)
	B4XPages.MainPage.newa.NewValue(common.Text)
	B4XPages.ShowPage("manage") ' manageButton
End Sub